{-# LANGUAGE MagicHash #-}

module Curry_Analysis(C_Declaration (..), C_Map, C_AnalysisFunction, C_NDResult, C_HOResult, d_C_getDeclName, d_C_getFunctionCalls, d_C_getCalls, d_C_fullIteration, nd_C_fullIteration, d_C_initNDResult, nd_C_initNDResult, d_C_analyseND, nd_C_analyseND, d_C_ndFunc, nd_C_ndFunc, d_C_isNDExpr, nd_C_isNDExpr, d_C_qmark, d_C_initHOResult, nd_C_initHOResult, d_C_analyseHOFunc, nd_C_analyseHOFunc, d_C_analyseHOCons, nd_C_analyseHOCons, d_C_consOrder, d_C_hoOr, d_C_ordFunc, nd_C_ordFunc, d_C_goThroughConsList, nd_C_goThroughConsList, d_C_ordHelp1, nd_C_ordHelp1, d_C_ordHelp2, nd_C_ordHelp2) where

import Basics
import qualified Curry_Base
import qualified Curry_Dependency2
import qualified Curry_FiniteMap
import qualified Curry_FlatCurry
import qualified Curry_FlatCurryGoodies
import qualified Curry_Maybe
import qualified Curry_Names
import qualified Curry_Prelude
type C_Map t0 = Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0

type C_AnalysisFunction t0 t1 = Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t1 -> ConstStore -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t1

type C_NDResult = Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass

type C_HOResult = Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass

data C_Declaration
     = C_F Curry_FlatCurry.C_FuncDecl
     | C_T Curry_FlatCurry.C_TypeDecl
     | Choice_C_Declaration ID C_Declaration C_Declaration
     | Choices_C_Declaration ID ([C_Declaration])
     | Fail_C_Declaration
     | Guard_C_Declaration Constraints C_Declaration

instance Show C_Declaration where
  showsPrec d (Choice_C_Declaration i x y) = showsChoice d i x y
  showsPrec d (Choices_C_Declaration i xs) = showsChoices d i xs
  showsPrec d (Guard_C_Declaration c e) = showsGuard d c e
  showsPrec _ Fail_C_Declaration = showChar '!'
  showsPrec _ (C_F x1) = (showString "(F") . ((showChar ' ') . ((shows x1) . (showChar ')')))
  showsPrec _ (C_T x1) = (showString "(T") . ((showChar ' ') . ((shows x1) . (showChar ')')))


instance Read C_Declaration where
  readsPrec d s = (readParen (d > 10) (\r -> [ (C_F x1,r1) | (_,r0) <- readQualified "Analysis" "F" r, (x1,r1) <- readsPrec 11 r0]) s) ++ (readParen (d > 10) (\r -> [ (C_T x1,r1) | (_,r0) <- readQualified "Analysis" "T" r, (x1,r1) <- readsPrec 11 r0]) s)


instance NonDet C_Declaration where
  choiceCons = Choice_C_Declaration
  choicesCons = Choices_C_Declaration
  failCons = Fail_C_Declaration
  guardCons = Guard_C_Declaration
  try (Choice_C_Declaration i x y) = tryChoice i x y
  try (Choices_C_Declaration i xs) = tryChoices i xs
  try Fail_C_Declaration = Fail
  try (Guard_C_Declaration c e) = Guard c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Declaration i x y) = f i x y
  match _ f _ _ _ _ (Choices_C_Declaration i@(NarrowedID _ _) xs) = f i xs
  match _ _ f _ _ _ (Choices_C_Declaration i@(FreeID _ _) xs) = f i xs
  match _ _ _ _ _ _ (Choices_C_Declaration i@(ChoiceID _) _) = error ("Analysis.Declaration.match: Choices with ChoiceID " ++ (show i))
  match _ _ _ f _ _ Fail_C_Declaration = f
  match _ _ _ _ f _ (Guard_C_Declaration c e) = f c e
  match _ _ _ _ _ f x = f x


instance Generable C_Declaration where
  generate s = Choices_C_Declaration (freeID [1,1] s) [(C_F (generate (leftSupply s))),(C_T (generate (leftSupply s)))]


instance NormalForm C_Declaration where
  ($!!) cont (C_F x1) cs = ((\y1 cs -> cont (C_F y1) cs) $!! x1) cs
  ($!!) cont (C_T x1) cs = ((\y1 cs -> cont (C_T y1) cs) $!! x1) cs
  ($!!) cont (Choice_C_Declaration i x y) cs = nfChoice cont i x y cs
  ($!!) cont (Choices_C_Declaration i xs) cs = nfChoices cont i xs cs
  ($!!) cont (Guard_C_Declaration c x) cs = guardCons c ((cont $!! x) (addCs c cs))
  ($!!) _ Fail_C_Declaration _ = failCons
  ($##) cont (C_F x1) cs = ((\y1 cs -> cont (C_F y1) cs) $## x1) cs
  ($##) cont (C_T x1) cs = ((\y1 cs -> cont (C_T y1) cs) $## x1) cs
  ($##) cont (Choice_C_Declaration i x y) cs = gnfChoice cont i x y cs
  ($##) cont (Choices_C_Declaration i xs) cs = gnfChoices cont i xs cs
  ($##) cont (Guard_C_Declaration c x) cs = guardCons c ((cont $## x) (addCs c cs))
  ($##) _ Fail_C_Declaration _ = failCons
  ($!<) cont (C_F x1) = (\y1 -> cont (C_F y1)) $!< x1
  ($!<) cont (C_T x1) = (\y1 -> cont (C_T y1)) $!< x1
  ($!<) cont (Choice_C_Declaration i x y) = nfChoiceIO cont i x y
  ($!<) cont (Choices_C_Declaration i xs) = nfChoicesIO cont i xs
  ($!<) cont x = cont x
  searchNF search cont (C_F x1) = search (\y1 -> cont (C_F y1)) x1
  searchNF search cont (C_T x1) = search (\y1 -> cont (C_T y1)) x1
  searchNF _ _ x = error ("Analysis.Declaration.searchNF: no constructor: " ++ (show x))


instance Unifiable C_Declaration where
  (=.=) (C_F x1) (C_F y1) cs = (x1 =:= y1) cs
  (=.=) (C_T x1) (C_T y1) cs = (x1 =:= y1) cs
  (=.=) _ _ _ = Fail_C_Success
  (=.<=) (C_F x1) (C_F y1) cs = (x1 =:<= y1) cs
  (=.<=) (C_T x1) (C_T y1) cs = (x1 =:<= y1) cs
  (=.<=) _ _ _ = Fail_C_Success
  bind i (C_F x2) = ((i :=: (ChooseN 0 1)):(concat [(bind (leftID i) x2)]))
  bind i (C_T x2) = ((i :=: (ChooseN 1 1)):(concat [(bind (leftID i) x2)]))
  bind i (Choice_C_Declaration j l r) = [(ConstraintChoice j (bind i l) (bind i r))]
  bind i (Choices_C_Declaration j@(FreeID _ _) _) = [(i :=: (BindTo j))]
  bind i (Choices_C_Declaration j@(NarrowedID _ _) xs) = [(ConstraintChoices j (map (bind i) xs))]
  bind _ (Choices_C_Declaration i@(ChoiceID _) _) = error ("Analysis.Declaration.bind: Choices with ChoiceID: " ++ (show i))
  bind _ Fail_C_Declaration = [Unsolvable]
  bind i (Guard_C_Declaration c e) = (getConstrList c) ++ (bind i e)
  lazyBind i (C_F x2) = [(i :=: (ChooseN 0 1)),((leftID i) :=: (LazyBind (lazyBind (leftID i) x2)))]
  lazyBind i (C_T x2) = [(i :=: (ChooseN 1 1)),((leftID i) :=: (LazyBind (lazyBind (leftID i) x2)))]
  lazyBind i (Choice_C_Declaration j l r) = [(ConstraintChoice j (lazyBind i l) (lazyBind i r))]
  lazyBind i (Choices_C_Declaration j@(FreeID _ _) _) = [(i :=: (BindTo j))]
  lazyBind i (Choices_C_Declaration j@(NarrowedID _ _) xs) = [(ConstraintChoices j (map (lazyBind i) xs))]
  lazyBind _ (Choices_C_Declaration i@(ChoiceID _) _) = error ("Analysis.Declaration.lazyBind: Choices with ChoiceID: " ++ (show i))
  lazyBind _ Fail_C_Declaration = [Unsolvable]
  lazyBind i (Guard_C_Declaration c e) = (getConstrList c) ++ [(i :=: (LazyBind (lazyBind i e)))]


instance Curry_Prelude.Curry C_Declaration where
  (=?=) (Choice_C_Declaration i x y) z cs = narrow i ((x Curry_Prelude.=?= z) cs) ((y Curry_Prelude.=?= z) cs)
  (=?=) (Choices_C_Declaration i xs) y cs = narrows cs i (\x -> (x Curry_Prelude.=?= y) cs) xs
  (=?=) (Guard_C_Declaration c e) y cs = guardCons c ((e Curry_Prelude.=?= y) (addCs c cs))
  (=?=) Fail_C_Declaration _ _ = failCons
  (=?=) z (Choice_C_Declaration i x y) cs = narrow i ((z Curry_Prelude.=?= x) cs) ((z Curry_Prelude.=?= y) cs)
  (=?=) y (Choices_C_Declaration i xs) cs = narrows cs i (\x -> (y Curry_Prelude.=?= x) cs) xs
  (=?=) y (Guard_C_Declaration c e) cs = guardCons c ((y Curry_Prelude.=?= e) (addCs c cs))
  (=?=) _ Fail_C_Declaration _ = failCons
  (=?=) (C_F x1) (C_F y1) cs = (x1 Curry_Prelude.=?= y1) cs
  (=?=) (C_T x1) (C_T y1) cs = (x1 Curry_Prelude.=?= y1) cs
  (=?=) _ _ _ = Curry_Prelude.C_False
  (<?=) (Choice_C_Declaration i x y) z cs = narrow i ((x Curry_Prelude.<?= z) cs) ((y Curry_Prelude.<?= z) cs)
  (<?=) (Choices_C_Declaration i xs) y cs = narrows cs i (\x -> (x Curry_Prelude.<?= y) cs) xs
  (<?=) (Guard_C_Declaration c e) y cs = guardCons c ((e Curry_Prelude.<?= y) (addCs c cs))
  (<?=) Fail_C_Declaration _ _ = failCons
  (<?=) z (Choice_C_Declaration i x y) cs = narrow i ((z Curry_Prelude.<?= x) cs) ((z Curry_Prelude.<?= y) cs)
  (<?=) y (Choices_C_Declaration i xs) cs = narrows cs i (\x -> (y Curry_Prelude.<?= x) cs) xs
  (<?=) y (Guard_C_Declaration c e) cs = guardCons c ((y Curry_Prelude.<?= e) (addCs c cs))
  (<?=) _ Fail_C_Declaration _ = failCons
  (<?=) (C_F x1) (C_F y1) cs = (x1 Curry_Prelude.<?= y1) cs
  (<?=) (C_F _) (C_T _) _ = Curry_Prelude.C_True
  (<?=) (C_T x1) (C_T y1) cs = (x1 Curry_Prelude.<?= y1) cs
  (<?=) _ _ _ = Curry_Prelude.C_False


d_C_getDeclName :: C_Declaration -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getDeclName x1 x3500 = case x1 of
     (C_F x2) -> Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_funcName x3500) x2 x3500
     (C_T x3) -> Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_typeName x3500) x3 x3500
     (Choice_C_Declaration x1000 x1001 x1002) -> narrow x1000 (d_C_getDeclName x1001 x3500) (d_C_getDeclName x1002 x3500)
     (Choices_C_Declaration x1000 x1001) -> narrows x3500 x1000 (\z -> d_C_getDeclName z x3500) x1001
     (Guard_C_Declaration x1000 x1001) -> guardCons x1000 ((d_C_getDeclName x1001) $! (addCs x1000 x3500))
     _ -> failCons

d_C_getFunctionCalls :: Curry_Prelude.OP_List Curry_FlatCurry.C_FuncDecl -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_FuncDecl (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
d_C_getFunctionCalls x1 x3500 = Curry_Prelude.d_C_map d_OP_getFunctionCalls_dot___hash_lambda2 x1 x3500

d_OP_getFunctionCalls_dot___hash_lambda2 :: Curry_FlatCurry.C_FuncDecl -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_FuncDecl (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_getFunctionCalls_dot___hash_lambda2 x1 x3500 = Curry_Prelude.OP_Tuple2 x1 (Curry_Dependency2.d_C_callsDirectly x1 x3500)

d_C_getCalls :: Curry_Prelude.OP_List C_Declaration -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 C_Declaration (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
d_C_getCalls x1 x3500 = Curry_Prelude.d_C_map d_OP_getCalls_dot___hash_lambda4 x1 x3500

d_OP_getCalls_dot_callHelp_dot_12 :: C_Declaration -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_getCalls_dot_callHelp_dot_12 x1 x3500 = case x1 of
     (C_F x2) -> Curry_Dependency2.d_C_callsDirectly x2 x3500
     (C_T x3) -> Curry_Dependency2.d_C_callsDirectly2 x3 x3500
     (Choice_C_Declaration x1000 x1001 x1002) -> narrow x1000 (d_OP_getCalls_dot_callHelp_dot_12 x1001 x3500) (d_OP_getCalls_dot_callHelp_dot_12 x1002 x3500)
     (Choices_C_Declaration x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP_getCalls_dot_callHelp_dot_12 z x3500) x1001
     (Guard_C_Declaration x1000 x1001) -> guardCons x1000 ((d_OP_getCalls_dot_callHelp_dot_12 x1001) $! (addCs x1000 x3500))
     _ -> failCons

d_OP_getCalls_dot___hash_lambda4 :: C_Declaration -> ConstStore -> Curry_Prelude.OP_Tuple2 C_Declaration (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_getCalls_dot___hash_lambda4 x1 x3500 = Curry_Prelude.OP_Tuple2 x1 (d_OP_getCalls_dot_callHelp_dot_12 x1 x3500)

d_C_fullIteration :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0
d_C_fullIteration x1 x2 x3 x4 x3500 = let
     x5 = Curry_Prelude.d_OP_dollar (Curry_FiniteMap.d_C_listToFM (acceptCs id Curry_Prelude.d_OP_lt) x3500) (Curry_Prelude.d_C_map (Curry_Prelude.d_C_apply x1 (Curry_FiniteMap.d_C_plusFM x3 x4 x3500) x3500) x2 x3500) x3500
      in (d_OP__case_15 x1 x2 x3 x4 x5 (Curry_FiniteMap.d_C_eqFM x4 x5 x3500) x3500)

nd_C_fullIteration :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Func (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0) (Func (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> IDSupply -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0
nd_C_fullIteration x1 x2 x3 x4 x3000 x3500 = let
     x2012 = x3000
      in (seq x2012 (let
          x2007 = leftSupply x2012
          x2011 = rightSupply x2012
           in (seq x2007 (seq x2011 (let
               x5 = let
                    x2006 = leftSupply x2007
                    x2008 = rightSupply x2007
                     in (seq x2006 (seq x2008 (let
                         x2000 = leftSupply x2008
                         x2005 = rightSupply x2008
                          in (seq x2000 (seq x2005 (Curry_Prelude.nd_OP_dollar (Curry_FiniteMap.nd_C_listToFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2000 x3500) (let
                              x2004 = leftSupply x2005
                              x2003 = rightSupply x2005
                               in (seq x2004 (seq x2003 (Curry_Prelude.nd_C_map (let
                                   x2002 = leftSupply x2003
                                   x2001 = rightSupply x2003
                                    in (seq x2002 (seq x2001 (Curry_Prelude.nd_C_apply x1 (Curry_FiniteMap.nd_C_plusFM x3 x4 x2001 x3500) x2002 x3500)))) x2 x2004 x3500)))) x2006 x3500))))))
                in (let
                    x2010 = leftSupply x2011
                    x2009 = rightSupply x2011
                     in (seq x2010 (seq x2009 (nd_OP__case_15 x1 x2 x3 x4 x5 (Curry_FiniteMap.nd_C_eqFM x4 x5 x2009 x3500) x2010 x3500)))))))))

d_C_initNDResult :: ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass
d_C_initNDResult x3500 = Curry_Prelude.d_C_apply (Curry_FiniteMap.d_C_listToFM (acceptCs id Curry_Prelude.d_OP_lt) x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (d_C_qmark x3500) Curry_Base.C_ND) Curry_Prelude.OP_List) x3500

nd_C_initNDResult :: IDSupply -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass
nd_C_initNDResult x3000 x3500 = let
     x2002 = x3000
      in (seq x2002 (let
          x2001 = leftSupply x2002
          x2000 = rightSupply x2002
           in (seq x2001 (seq x2000 (Curry_Prelude.nd_C_apply (Curry_FiniteMap.nd_C_listToFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2000 x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 (d_C_qmark x3500) Curry_Base.C_ND) Curry_Prelude.OP_List) x2001 x3500)))))

d_C_analyseND :: Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass
d_C_analyseND x1 x2 x3500 = let
     x3 = Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_progFuncs x3500) x1 x3500
     x4 = Curry_Prelude.d_OP_dollar (Curry_FiniteMap.d_C_listToFM (acceptCs id Curry_Prelude.d_OP_lt) x3500) (Curry_Prelude.d_C_map d_OP_analyseND_dot___hash_lambda5 x3 x3500) x3500
      in (d_C_fullIteration (acceptCs id d_C_ndFunc) (d_C_getFunctionCalls x3 x3500) x2 x4 x3500)

nd_C_analyseND :: Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass -> IDSupply -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass
nd_C_analyseND x1 x2 x3000 x3500 = let
     x2009 = x3000
      in (seq x2009 (let
          x2002 = leftSupply x2009
          x2010 = rightSupply x2009
           in (seq x2002 (seq x2010 (let
               x2006 = leftSupply x2010
               x2008 = rightSupply x2010
                in (seq x2006 (seq x2008 (let
                    x3 = let
                         x2001 = leftSupply x2002
                         x2000 = rightSupply x2002
                          in (seq x2001 (seq x2000 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_progFuncs x2000 x3500) x1 x2001 x3500)))
                    x4 = let
                         x2005 = leftSupply x2006
                         x2007 = rightSupply x2006
                          in (seq x2005 (seq x2007 (let
                              x2003 = leftSupply x2007
                              x2004 = rightSupply x2007
                               in (seq x2003 (seq x2004 (Curry_Prelude.nd_OP_dollar (Curry_FiniteMap.nd_C_listToFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2003 x3500) (Curry_Prelude.nd_C_map (wrapDX id d_OP_analyseND_dot___hash_lambda5) x3 x2004 x3500) x2005 x3500))))))
                     in (nd_C_fullIteration (wrapDX (wrapNX id) (acceptCs id nd_C_ndFunc)) (d_C_getFunctionCalls x3 x3500) x2 x4 x2008 x3500)))))))))

d_OP_analyseND_dot___hash_lambda5 :: Curry_FlatCurry.C_FuncDecl -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass
d_OP_analyseND_dot___hash_lambda5 x1 x3500 = let
     x2 = Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_funcName x3500) x1 x3500
      in (Curry_Prelude.OP_Tuple2 x2 (d_OP__case_14 x2 (Curry_Prelude.d_OP_eq_eq x2 (d_C_qmark x3500) x3500) x3500))

d_C_ndFunc :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass -> Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_FuncDecl (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass
d_C_ndFunc x1 x2 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> let
          x5 = Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_funcName x3500) x3 x3500
          x6 = Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_funcRule x3500) x3 x3500
          x7 = Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_any (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq) (Curry_Prelude.C_Just Curry_Base.C_ND)) x3500) (Curry_Prelude.d_C_map (Curry_FiniteMap.d_C_lookupFM x1) x4 x3500) x3500
          x8 = Curry_Prelude.OP_Tuple2 x5 (Curry_Prelude.d_OP_dollar Curry_Maybe.d_C_fromJust (Curry_FiniteMap.d_C_lookupFM x1 x5 x3500) x3500)
           in (d_OP__case_13 x5 x6 x7 x8 (Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_isRuleExternal x3500) x6 x3500) x3500)
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002) -> narrow x1000 (d_C_ndFunc x1 x1001 x3500) (d_C_ndFunc x1 x1002 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001) -> narrows x3500 x1000 (\z -> d_C_ndFunc x1 z x3500) x1001
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001) -> guardCons x1000 ((d_C_ndFunc x1 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_C_ndFunc :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass -> Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_FuncDecl (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> IDSupply -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_NDClass
nd_C_ndFunc x1 x2 x3000 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> let
          x2019 = x3000
           in (seq x2019 (let
               x2020 = leftSupply x2019
               x2021 = rightSupply x2019
                in (seq x2020 (seq x2021 (let
                    x2002 = leftSupply x2020
                    x2005 = rightSupply x2020
                     in (seq x2002 (seq x2005 (let
                         x2009 = leftSupply x2021
                         x2022 = rightSupply x2021
                          in (seq x2009 (seq x2022 (let
                              x2013 = leftSupply x2022
                              x2018 = rightSupply x2022
                               in (seq x2013 (seq x2018 (let
                                   x5 = let
                                        x2001 = leftSupply x2002
                                        x2000 = rightSupply x2002
                                         in (seq x2001 (seq x2000 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_funcName x2000 x3500) x3 x2001 x3500)))
                                   x6 = let
                                        x2004 = leftSupply x2005
                                        x2003 = rightSupply x2005
                                         in (seq x2004 (seq x2003 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_funcRule x2003 x3500) x3 x2004 x3500)))
                                   x7 = let
                                        x2008 = leftSupply x2009
                                        x2010 = rightSupply x2009
                                         in (seq x2008 (seq x2010 (let
                                             x2006 = leftSupply x2010
                                             x2007 = rightSupply x2010
                                              in (seq x2006 (seq x2007 (Curry_Prelude.nd_OP_dollar (Curry_Prelude.nd_C_any (wrapNX id (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_eq_eq)) (Curry_Prelude.C_Just Curry_Base.C_ND))) x2006 x3500) (Curry_Prelude.nd_C_map (wrapNX id (Curry_FiniteMap.nd_C_lookupFM x1)) x4 x2007 x3500) x2008 x3500))))))
                                   x8 = Curry_Prelude.OP_Tuple2 x5 (let
                                        x2012 = leftSupply x2013
                                        x2011 = rightSupply x2013
                                         in (seq x2012 (seq x2011 (Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Maybe.d_C_fromJust) (Curry_FiniteMap.nd_C_lookupFM x1 x5 x2011 x3500) x2012 x3500))))
                                    in (let
                                        x2017 = leftSupply x2018
                                        x2016 = rightSupply x2018
                                         in (seq x2017 (seq x2016 (nd_OP__case_13 x5 x6 x7 x8 (let
                                             x2015 = leftSupply x2016
                                             x2014 = rightSupply x2016
                                              in (seq x2015 (seq x2014 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_isRuleExternal x2014 x3500) x6 x2015 x3500)))) x2017 x3500))))))))))))))))))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002) -> narrow x1000 (nd_C_ndFunc x1 x1001 x3000 x3500) (nd_C_ndFunc x1 x1002 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001) -> narrows x3500 x1000 (\z -> nd_C_ndFunc x1 z x3000 x3500) x1001
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001) -> guardCons x1000 ((nd_C_ndFunc x1 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_C_isNDExpr :: ConstStore -> Curry_FlatCurry.C_Expr -> ConstStore -> Curry_Prelude.C_Bool
d_C_isNDExpr x3500 = Curry_FlatCurryGoodies.d_C_trExpr d_OP_isNDExpr_dot_cf_dot_41 d_OP_isNDExpr_dot_cf_dot_41 (acceptCs (acceptCs id) d_OP_isNDExpr_dot_combf_dot_41) (acceptCs id d_OP_isNDExpr_dot_letf_dot_41) (acceptCs id d_OP_isNDExpr_dot_freef_dot_41) (acceptCs id d_OP_isNDExpr_dot_orf_dot_41) (acceptCs (acceptCs id) d_OP_isNDExpr_dot_casef_dot_41) (acceptCs id d_OP_isNDExpr_dot_branchf_dot_41)

nd_C_isNDExpr :: IDSupply -> ConstStore -> Func Curry_FlatCurry.C_Expr Curry_Prelude.C_Bool
nd_C_isNDExpr x3000 x3500 = wrapNX id (Curry_FlatCurryGoodies.nd_C_trExpr (wrapDX id d_OP_isNDExpr_dot_cf_dot_41) (wrapDX id d_OP_isNDExpr_dot_cf_dot_41) (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs id) d_OP_isNDExpr_dot_combf_dot_41)) (wrapDX (wrapDX id) (acceptCs id d_OP_isNDExpr_dot_letf_dot_41)) (wrapDX (wrapDX id) (acceptCs id d_OP_isNDExpr_dot_freef_dot_41)) (wrapDX (wrapDX id) (acceptCs id d_OP_isNDExpr_dot_orf_dot_41)) (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs id) d_OP_isNDExpr_dot_casef_dot_41)) (wrapDX (wrapDX id) (acceptCs id d_OP_isNDExpr_dot_branchf_dot_41)))

d_OP_isNDExpr_dot_cf_dot_41 :: Curry_Prelude.Curry t0 => t0 -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isNDExpr_dot_cf_dot_41 x1 x3500 = Curry_Prelude.d_C_const Curry_Prelude.C_False x1 x3500

d_OP_isNDExpr_dot_combf_dot_41 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> t1 -> Curry_Prelude.OP_List Curry_Prelude.C_Bool -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isNDExpr_dot_combf_dot_41 x1 x2 x3 x3500 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_or x3500) x3 x3500

d_OP_isNDExpr_dot_letf_dot_41 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 Curry_Prelude.C_Bool) -> Curry_Prelude.C_Bool -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isNDExpr_dot_letf_dot_41 x1 x2 x3500 = Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_or x3500) (Curry_Prelude.OP_Cons x2 (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x1 x3500)) x3500

d_OP_isNDExpr_dot_freef_dot_41 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> t1 -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isNDExpr_dot_freef_dot_41 x1 x2 x3500 = Curry_Prelude.C_True

d_OP_isNDExpr_dot_orf_dot_41 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> t1 -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isNDExpr_dot_orf_dot_41 x1 x2 x3500 = Curry_Prelude.C_True

d_OP_isNDExpr_dot_casef_dot_41 :: Curry_Prelude.Curry t0 => t0 -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Bool -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isNDExpr_dot_casef_dot_41 x1 x2 x3 x3500 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_or x3500) (Curry_Prelude.OP_Cons x2 x3) x3500

d_OP_isNDExpr_dot_branchf_dot_41 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> t1 -> ConstStore -> t1
d_OP_isNDExpr_dot_branchf_dot_41 x1 x2 x3500 = x2

d_C_qmark :: ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_qmark x3500 = Curry_Names.d_C_renameQName (Curry_Prelude.OP_Tuple2 (Curry_Names.d_C_prelude x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '?'#) Curry_Prelude.OP_List)) x3500

d_C_initHOResult :: ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
d_C_initHOResult x3500 = Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) x3500

nd_C_initHOResult :: IDSupply -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
nd_C_initHOResult x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2000 x3500))

d_C_analyseHOFunc :: Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
d_C_analyseHOFunc x1 x2 x3500 = let
     x3 = Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_map (acceptCs id C_F)) (Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_progFuncs x3500) x1 x3500) x3500
     x4 = Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_map (acceptCs id C_T)) (Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_progTypes x3500) x1 x3500) x3500
     x5 = Curry_Prelude.d_OP_plus_plus x3 x4 x3500
     x6 = Curry_Prelude.d_OP_dollar (Curry_FiniteMap.d_C_listToFM (acceptCs id Curry_Prelude.d_OP_lt) x3500) (Curry_Prelude.d_C_map d_OP_analyseHOFunc_dot___hash_lambda6 x5 x3500) x3500
      in (d_C_fullIteration (acceptCs id d_C_ordFunc) (d_C_getCalls x5 x3500) x2 x6 x3500)

nd_C_analyseHOFunc :: Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> IDSupply -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
nd_C_analyseHOFunc x1 x2 x3000 x3500 = let
     x2016 = x3000
      in (seq x2016 (let
          x2017 = leftSupply x2016
          x2018 = rightSupply x2016
           in (seq x2017 (seq x2018 (let
               x2004 = leftSupply x2017
               x2009 = rightSupply x2017
                in (seq x2004 (seq x2009 (let
                    x2013 = leftSupply x2018
                    x2015 = rightSupply x2018
                     in (seq x2013 (seq x2015 (let
                         x3 = let
                              x2003 = leftSupply x2004
                              x2002 = rightSupply x2004
                               in (seq x2003 (seq x2002 (Curry_Prelude.nd_OP_dollar (wrapNX id (Curry_Prelude.nd_C_map (wrapDX id (acceptCs id C_F)))) (let
                                   x2001 = leftSupply x2002
                                   x2000 = rightSupply x2002
                                    in (seq x2001 (seq x2000 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_progFuncs x2000 x3500) x1 x2001 x3500)))) x2003 x3500)))
                         x4 = let
                              x2008 = leftSupply x2009
                              x2007 = rightSupply x2009
                               in (seq x2008 (seq x2007 (Curry_Prelude.nd_OP_dollar (wrapNX id (Curry_Prelude.nd_C_map (wrapDX id (acceptCs id C_T)))) (let
                                   x2006 = leftSupply x2007
                                   x2005 = rightSupply x2007
                                    in (seq x2006 (seq x2005 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_progTypes x2005 x3500) x1 x2006 x3500)))) x2008 x3500)))
                         x5 = Curry_Prelude.d_OP_plus_plus x3 x4 x3500
                         x6 = let
                              x2012 = leftSupply x2013
                              x2014 = rightSupply x2013
                               in (seq x2012 (seq x2014 (let
                                   x2010 = leftSupply x2014
                                   x2011 = rightSupply x2014
                                    in (seq x2010 (seq x2011 (Curry_Prelude.nd_OP_dollar (Curry_FiniteMap.nd_C_listToFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2010 x3500) (Curry_Prelude.nd_C_map (wrapDX id d_OP_analyseHOFunc_dot___hash_lambda6) x5 x2011 x3500) x2012 x3500))))))
                          in (nd_C_fullIteration (wrapDX (wrapNX id) (acceptCs id nd_C_ordFunc)) (d_C_getCalls x5 x3500) x2 x6 x2015 x3500))))))))))))

d_OP_analyseHOFunc_dot___hash_lambda6 :: C_Declaration -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
d_OP_analyseHOFunc_dot___hash_lambda6 x1 x3500 = Curry_Prelude.OP_Tuple2 (d_C_getDeclName x1 x3500) Curry_Base.C_FO

d_C_analyseHOCons :: Curry_FlatCurry.C_Prog -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
d_C_analyseHOCons x1 x3500 = Curry_Prelude.d_OP_dollar (Curry_FiniteMap.d_C_listToFM (acceptCs id Curry_Prelude.d_OP_lt) x3500) (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_map d_C_consOrder) (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_concatMap (Curry_FlatCurryGoodies.d_C_typeConsDecls x3500) x3500) (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot Curry_Prelude.d_C_not (Curry_FlatCurryGoodies.d_C_isTypeSyn x3500) x3500)) (Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_progTypes x3500) x1 x3500) x3500) x3500) x3500) x3500

nd_C_analyseHOCons :: Curry_FlatCurry.C_Prog -> IDSupply -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
nd_C_analyseHOCons x1 x3000 x3500 = let
     x2019 = x3000
      in (seq x2019 (let
          x2018 = leftSupply x2019
          x2020 = rightSupply x2019
           in (seq x2018 (seq x2020 (let
               x2000 = leftSupply x2020
               x2017 = rightSupply x2020
                in (seq x2000 (seq x2017 (Curry_Prelude.nd_OP_dollar (Curry_FiniteMap.nd_C_listToFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2000 x3500) (let
                    x2016 = leftSupply x2017
                    x2014 = rightSupply x2017
                     in (seq x2016 (seq x2014 (Curry_Prelude.nd_OP_dollar (wrapNX id (Curry_Prelude.nd_C_map (wrapDX id d_C_consOrder))) (let
                         x2013 = leftSupply x2014
                         x2015 = rightSupply x2014
                          in (seq x2013 (seq x2015 (let
                              x2003 = leftSupply x2015
                              x2011 = rightSupply x2015
                               in (seq x2003 (seq x2011 (Curry_Prelude.nd_OP_dollar (let
                                   x2002 = leftSupply x2003
                                   x2001 = rightSupply x2003
                                    in (seq x2002 (seq x2001 (Curry_Prelude.nd_C_concatMap (Curry_FlatCurryGoodies.nd_C_typeConsDecls x2001 x3500) x2002 x3500)))) (let
                                   x2010 = leftSupply x2011
                                   x2012 = rightSupply x2011
                                    in (seq x2010 (seq x2012 (let
                                        x2006 = leftSupply x2012
                                        x2009 = rightSupply x2012
                                         in (seq x2006 (seq x2009 (Curry_Prelude.nd_OP_dollar (wrapNX id (Curry_Prelude.nd_C_filter (let
                                             x2005 = leftSupply x2006
                                             x2004 = rightSupply x2006
                                              in (seq x2005 (seq x2004 (Curry_Prelude.nd_OP_dot (wrapDX id Curry_Prelude.d_C_not) (Curry_FlatCurryGoodies.nd_C_isTypeSyn x2004 x3500) x2005 x3500)))))) (let
                                             x2008 = leftSupply x2009
                                             x2007 = rightSupply x2009
                                              in (seq x2008 (seq x2007 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_progTypes x2007 x3500) x1 x2008 x3500)))) x2010 x3500))))))) x2013 x3500))))))) x2016 x3500)))) x2018 x3500))))))))

d_C_consOrder :: Curry_FlatCurry.C_ConsDecl -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
d_C_consOrder x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Cons x2 x3 x4 x5) -> Curry_Prelude.OP_Tuple2 x2 (d_OP_consOrder_dot_consOrder'_dot_81 x5 x3500)
     (Curry_FlatCurry.Choice_C_ConsDecl x1000 x1001 x1002) -> narrow x1000 (d_C_consOrder x1001 x3500) (d_C_consOrder x1002 x3500)
     (Curry_FlatCurry.Choices_C_ConsDecl x1000 x1001) -> narrows x3500 x1000 (\z -> d_C_consOrder z x3500) x1001
     (Curry_FlatCurry.Guard_C_ConsDecl x1000 x1001) -> guardCons x1000 ((d_C_consOrder x1001) $! (addCs x1000 x3500))
     _ -> failCons

d_OP_consOrder_dot_consOrder'_dot_81 :: Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Base.C_HOClass
d_OP_consOrder_dot_consOrder'_dot_81 x1 x3500 = case x1 of
     Curry_Prelude.OP_List -> Curry_Base.C_FO
     (Curry_Prelude.OP_Cons x2 x3) -> d_OP__case_9 x3 x2 x3500
     (Curry_Prelude.Choice_OP_List x1000 x1001 x1002) -> narrow x1000 (d_OP_consOrder_dot_consOrder'_dot_81 x1001 x3500) (d_OP_consOrder_dot_consOrder'_dot_81 x1002 x3500)
     (Curry_Prelude.Choices_OP_List x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP_consOrder_dot_consOrder'_dot_81 z x3500) x1001
     (Curry_Prelude.Guard_OP_List x1000 x1001) -> guardCons x1000 ((d_OP_consOrder_dot_consOrder'_dot_81 x1001) $! (addCs x1000 x3500))
     _ -> failCons

d_C_hoOr :: Curry_Base.C_HOClass -> Curry_Base.C_HOClass -> ConstStore -> Curry_Base.C_HOClass
d_C_hoOr x1 x2 x3500 = case x1 of
     Curry_Base.C_HO -> Curry_Base.C_HO
     Curry_Base.C_FO -> x2
     (Curry_Base.Choice_C_HOClass x1000 x1001 x1002) -> narrow x1000 (d_C_hoOr x1001 x2 x3500) (d_C_hoOr x1002 x2 x3500)
     (Curry_Base.Choices_C_HOClass x1000 x1001) -> narrows x3500 x1000 (\z -> d_C_hoOr z x2 x3500) x1001
     (Curry_Base.Guard_C_HOClass x1000 x1001) -> guardCons x1000 ((d_C_hoOr x1001 x2) $! (addCs x1000 x3500))
     _ -> failCons

d_C_ordFunc :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_Prelude.OP_Tuple2 C_Declaration (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
d_C_ordFunc x1 x2 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> d_OP__case_8 x1 x3 x3500
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002) -> narrow x1000 (d_C_ordFunc x1 x1001 x3500) (d_C_ordFunc x1 x1002 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001) -> narrows x3500 x1000 (\z -> d_C_ordFunc x1 z x3500) x1001
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001) -> guardCons x1000 ((d_C_ordFunc x1 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_C_ordFunc :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_Prelude.OP_Tuple2 C_Declaration (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> IDSupply -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass
nd_C_ordFunc x1 x2 x3000 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_8 x1 x3 x2000 x3500))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002) -> narrow x1000 (nd_C_ordFunc x1 x1001 x3000 x3500) (nd_C_ordFunc x1 x1002 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001) -> narrows x3500 x1000 (\z -> nd_C_ordFunc x1 z x3000 x3500) x1001
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001) -> guardCons x1000 ((nd_C_ordFunc x1 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_C_goThroughConsList :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_Prelude.OP_List Curry_FlatCurry.C_ConsDecl -> ConstStore -> Curry_Base.C_HOClass
d_C_goThroughConsList x1 x2 x3500 = case x2 of
     Curry_Prelude.OP_List -> Curry_Base.C_FO
     (Curry_Prelude.OP_Cons x3 x4) -> let
          x5 = x3
          x6 = d_OP_goThroughConsList_dot___hash_selFP2_hash_typeExprs x5 x3500
           in (d_C_hoOr (Curry_Prelude.d_C_foldr (acceptCs id (d_OP_goThroughConsList_dot___hash_lambda8 x1)) Curry_Base.C_FO x6 x3500) (d_C_goThroughConsList x1 x4 x3500) x3500)
     (Curry_Prelude.Choice_OP_List x1000 x1001 x1002) -> narrow x1000 (d_C_goThroughConsList x1 x1001 x3500) (d_C_goThroughConsList x1 x1002 x3500)
     (Curry_Prelude.Choices_OP_List x1000 x1001) -> narrows x3500 x1000 (\z -> d_C_goThroughConsList x1 z x3500) x1001
     (Curry_Prelude.Guard_OP_List x1000 x1001) -> guardCons x1000 ((d_C_goThroughConsList x1 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_C_goThroughConsList :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_Prelude.OP_List Curry_FlatCurry.C_ConsDecl -> IDSupply -> ConstStore -> Curry_Base.C_HOClass
nd_C_goThroughConsList x1 x2 x3000 x3500 = case x2 of
     Curry_Prelude.OP_List -> Curry_Base.C_FO
     (Curry_Prelude.OP_Cons x3 x4) -> let
          x2002 = x3000
           in (seq x2002 (let
               x5 = x3
               x6 = d_OP_goThroughConsList_dot___hash_selFP2_hash_typeExprs x5 x3500
                in (let
                    x2000 = leftSupply x2002
                    x2001 = rightSupply x2002
                     in (seq x2000 (seq x2001 (d_C_hoOr (Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id (nd_OP_goThroughConsList_dot___hash_lambda8 x1))) Curry_Base.C_FO x6 x2000 x3500) (nd_C_goThroughConsList x1 x4 x2001 x3500) x3500))))))
     (Curry_Prelude.Choice_OP_List x1000 x1001 x1002) -> narrow x1000 (nd_C_goThroughConsList x1 x1001 x3000 x3500) (nd_C_goThroughConsList x1 x1002 x3000 x3500)
     (Curry_Prelude.Choices_OP_List x1000 x1001) -> narrows x3500 x1000 (\z -> nd_C_goThroughConsList x1 z x3000 x3500) x1001
     (Curry_Prelude.Guard_OP_List x1000 x1001) -> guardCons x1000 ((nd_C_goThroughConsList x1 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP_goThroughConsList_dot___hash_selFP2_hash_typeExprs :: Curry_FlatCurry.C_ConsDecl -> ConstStore -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr
d_OP_goThroughConsList_dot___hash_selFP2_hash_typeExprs x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Cons x2 x3 x4 x5) -> x5
     (Curry_FlatCurry.Choice_C_ConsDecl x1000 x1001 x1002) -> narrow x1000 (d_OP_goThroughConsList_dot___hash_selFP2_hash_typeExprs x1001 x3500) (d_OP_goThroughConsList_dot___hash_selFP2_hash_typeExprs x1002 x3500)
     (Curry_FlatCurry.Choices_C_ConsDecl x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP_goThroughConsList_dot___hash_selFP2_hash_typeExprs z x3500) x1001
     (Curry_FlatCurry.Guard_C_ConsDecl x1000 x1001) -> guardCons x1000 ((d_OP_goThroughConsList_dot___hash_selFP2_hash_typeExprs x1001) $! (addCs x1000 x3500))
     _ -> failCons

d_OP_goThroughConsList_dot___hash_lambda8 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_FlatCurry.C_TypeExpr -> Curry_Base.C_HOClass -> ConstStore -> Curry_Base.C_HOClass
d_OP_goThroughConsList_dot___hash_lambda8 x1 x2 x3 x3500 = d_C_hoOr x3 (d_C_ordHelp1 x1 x2 x3500) x3500

nd_OP_goThroughConsList_dot___hash_lambda8 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_FlatCurry.C_TypeExpr -> Curry_Base.C_HOClass -> IDSupply -> ConstStore -> Curry_Base.C_HOClass
nd_OP_goThroughConsList_dot___hash_lambda8 x1 x2 x3 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (d_C_hoOr x3 (nd_C_ordHelp1 x1 x2 x2000 x3500) x3500))

d_C_ordHelp1 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Base.C_HOClass
d_C_ordHelp1 x1 x2 x3500 = case x2 of
     (Curry_FlatCurry.C_TVar x3) -> Curry_Base.C_FO
     (Curry_FlatCurry.C_FuncType x4 x5) -> Curry_Base.C_HO
     (Curry_FlatCurry.C_TCons x6 x7) -> d_C_hoOr (Curry_Maybe.d_C_fromMaybe Curry_Base.C_FO (Curry_FiniteMap.d_C_lookupFM x1 x6 x3500) x3500) (Curry_Prelude.d_C_foldr (acceptCs id (d_OP_ordHelp1_dot___hash_lambda9 x1)) Curry_Base.C_FO x7 x3500) x3500
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002) -> narrow x1000 (d_C_ordHelp1 x1 x1001 x3500) (d_C_ordHelp1 x1 x1002 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001) -> narrows x3500 x1000 (\z -> d_C_ordHelp1 x1 z x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001) -> guardCons x1000 ((d_C_ordHelp1 x1 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_C_ordHelp1 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Curry_Base.C_HOClass
nd_C_ordHelp1 x1 x2 x3000 x3500 = case x2 of
     (Curry_FlatCurry.C_TVar x3) -> Curry_Base.C_FO
     (Curry_FlatCurry.C_FuncType x4 x5) -> Curry_Base.C_HO
     (Curry_FlatCurry.C_TCons x6 x7) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2000 = leftSupply x2002
               x2001 = rightSupply x2002
                in (seq x2000 (seq x2001 (d_C_hoOr (Curry_Maybe.d_C_fromMaybe Curry_Base.C_FO (Curry_FiniteMap.nd_C_lookupFM x1 x6 x2000 x3500) x3500) (Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id (nd_OP_ordHelp1_dot___hash_lambda9 x1))) Curry_Base.C_FO x7 x2001 x3500) x3500)))))
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002) -> narrow x1000 (nd_C_ordHelp1 x1 x1001 x3000 x3500) (nd_C_ordHelp1 x1 x1002 x3000 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001) -> narrows x3500 x1000 (\z -> nd_C_ordHelp1 x1 z x3000 x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001) -> guardCons x1000 ((nd_C_ordHelp1 x1 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP_ordHelp1_dot___hash_lambda9 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_FlatCurry.C_TypeExpr -> Curry_Base.C_HOClass -> ConstStore -> Curry_Base.C_HOClass
d_OP_ordHelp1_dot___hash_lambda9 x1 x2 x3 x3500 = d_C_hoOr x3 (d_C_ordHelp1 x1 x2 x3500) x3500

nd_OP_ordHelp1_dot___hash_lambda9 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> Curry_FlatCurry.C_TypeExpr -> Curry_Base.C_HOClass -> IDSupply -> ConstStore -> Curry_Base.C_HOClass
nd_OP_ordHelp1_dot___hash_lambda9 x1 x2 x3 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (d_C_hoOr x3 (nd_C_ordHelp1 x1 x2 x2000 x3500) x3500))

d_C_ordHelp2 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Int -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> ConstStore -> Curry_Base.C_HOClass
d_C_ordHelp2 x1 x2 x3 x3500 = d_OP__case_6 x1 x2 x3 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 0#) x3500) x3500

nd_C_ordHelp2 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Int -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Base.C_HOClass -> IDSupply -> ConstStore -> Curry_Base.C_HOClass
nd_C_ordHelp2 x1 x2 x3 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (nd_OP__case_6 x1 x2 x3 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 0#) x3500) x2000 x3500))

d_OP__case_6 x1 x2 x3 x4 x3500 = case x4 of
     Curry_Prelude.C_True -> d_OP__case_5 x3 x1 x3500
     Curry_Prelude.C_False -> d_OP__case_1 x2 x3 x1 x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (d_OP__case_6 x1 x2 x3 x1001 x3500) (d_OP__case_6 x1 x2 x3 x1002 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_6 x1 x2 x3 z x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((d_OP__case_6 x1 x2 x3 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_6 x1 x2 x3 x4 x3000 x3500 = case x4 of
     Curry_Prelude.C_True -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_5 x3 x1 x2000 x3500))
     Curry_Prelude.C_False -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_1 x2 x3 x1 x2000 x3500))
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_6 x1 x2 x3 x1001 x3000 x3500) (nd_OP__case_6 x1 x2 x3 x1002 x3000 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_6 x1 x2 x3 z x3000 x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((nd_OP__case_6 x1 x2 x3 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_1 x2 x3 x1 x3500 = case x1 of
     (Curry_FlatCurry.C_TVar x15) -> d_OP__case_0 x15 (Curry_Prelude.d_OP_eq_eq x15 (Curry_Prelude.C_Int -42#) x3500) x3500
     (Curry_FlatCurry.C_FuncType x16 x17) -> let
          x18 = d_C_ordHelp2 x16 (Curry_Prelude.C_Int 0#) x3 x3500
          x19 = d_C_ordHelp2 x17 (Curry_Prelude.d_OP_minus x2 (Curry_Prelude.C_Int 1#) x3500) x3 x3500
           in (d_C_hoOr x18 x19 x3500)
     (Curry_FlatCurry.C_TCons x20 x21) -> Curry_Prelude.d_C_failed x3500
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002) -> narrow x1000 (d_OP__case_1 x2 x3 x1001 x3500) (d_OP__case_1 x2 x3 x1002 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_1 x2 x3 z x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001) -> guardCons x1000 ((d_OP__case_1 x2 x3 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_1 x2 x3 x1 x3000 x3500 = case x1 of
     (Curry_FlatCurry.C_TVar x15) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_0 x15 (Curry_Prelude.d_OP_eq_eq x15 (Curry_Prelude.C_Int -42#) x3500) x2000 x3500))
     (Curry_FlatCurry.C_FuncType x16 x17) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2000 = leftSupply x2002
               x2001 = rightSupply x2002
                in (seq x2000 (seq x2001 (let
                    x18 = nd_C_ordHelp2 x16 (Curry_Prelude.C_Int 0#) x3 x2000 x3500
                    x19 = nd_C_ordHelp2 x17 (Curry_Prelude.d_OP_minus x2 (Curry_Prelude.C_Int 1#) x3500) x3 x2001 x3500
                     in (d_C_hoOr x18 x19 x3500))))))
     (Curry_FlatCurry.C_TCons x20 x21) -> Curry_Prelude.d_C_failed x3500
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_1 x2 x3 x1001 x3000 x3500) (nd_OP__case_1 x2 x3 x1002 x3000 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_1 x2 x3 z x3000 x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001) -> guardCons x1000 ((nd_OP__case_1 x2 x3 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_0 x15 x16 x3500 = case x16 of
     Curry_Prelude.C_True -> Curry_Base.C_HO
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (d_OP__case_0 x15 x1001 x3500) (d_OP__case_0 x15 x1002 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_0 x15 z x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((d_OP__case_0 x15 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_0 x15 x16 x3000 x3500 = case x16 of
     Curry_Prelude.C_True -> Curry_Base.C_HO
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_0 x15 x1001 x3000 x3500) (nd_OP__case_0 x15 x1002 x3000 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_0 x15 z x3000 x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((nd_OP__case_0 x15 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_5 x3 x1 x3500 = case x1 of
     (Curry_FlatCurry.C_FuncType x4 x5) -> Curry_Base.C_HO
     (Curry_FlatCurry.C_TVar x6) -> d_OP__case_4 x6 (Curry_Prelude.d_OP_eq_eq x6 (Curry_Prelude.C_Int -42#) x3500) x3500
     (Curry_FlatCurry.C_TCons x7 x8) -> d_OP__case_3 x3 x7 x8 x3500
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002) -> narrow x1000 (d_OP__case_5 x3 x1001 x3500) (d_OP__case_5 x3 x1002 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_5 x3 z x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001) -> guardCons x1000 ((d_OP__case_5 x3 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_5 x3 x1 x3000 x3500 = case x1 of
     (Curry_FlatCurry.C_FuncType x4 x5) -> Curry_Base.C_HO
     (Curry_FlatCurry.C_TVar x6) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_4 x6 (Curry_Prelude.d_OP_eq_eq x6 (Curry_Prelude.C_Int -42#) x3500) x2000 x3500))
     (Curry_FlatCurry.C_TCons x7 x8) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_3 x3 x7 x8 x2000 x3500))
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_5 x3 x1001 x3000 x3500) (nd_OP__case_5 x3 x1002 x3000 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_5 x3 z x3000 x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001) -> guardCons x1000 ((nd_OP__case_5 x3 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_3 x3 x7 x8 x3500 = case x8 of
     (Curry_Prelude.OP_Cons x9 x10) -> let
          x11 = d_C_ordHelp2 x9 (Curry_Prelude.C_Int 0#) x3 x3500
          x12 = d_C_ordHelp2 (Curry_FlatCurry.C_TCons x7 x10) (Curry_Prelude.C_Int 0#) x3 x3500
           in (d_C_hoOr x11 x12 x3500)
     Curry_Prelude.OP_List -> d_OP__case_2 x3 x7 x3500
     (Curry_Prelude.Choice_OP_List x1000 x1001 x1002) -> narrow x1000 (d_OP__case_3 x3 x7 x1001 x3500) (d_OP__case_3 x3 x7 x1002 x3500)
     (Curry_Prelude.Choices_OP_List x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_3 x3 x7 z x3500) x1001
     (Curry_Prelude.Guard_OP_List x1000 x1001) -> guardCons x1000 ((d_OP__case_3 x3 x7 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_3 x3 x7 x8 x3000 x3500 = case x8 of
     (Curry_Prelude.OP_Cons x9 x10) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2000 = leftSupply x2002
               x2001 = rightSupply x2002
                in (seq x2000 (seq x2001 (let
                    x11 = nd_C_ordHelp2 x9 (Curry_Prelude.C_Int 0#) x3 x2000 x3500
                    x12 = nd_C_ordHelp2 (Curry_FlatCurry.C_TCons x7 x10) (Curry_Prelude.C_Int 0#) x3 x2001 x3500
                     in (d_C_hoOr x11 x12 x3500))))))
     Curry_Prelude.OP_List -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_2 x3 x7 x2000 x3500))
     (Curry_Prelude.Choice_OP_List x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_3 x3 x7 x1001 x3000 x3500) (nd_OP__case_3 x3 x7 x1002 x3000 x3500)
     (Curry_Prelude.Choices_OP_List x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_3 x3 x7 z x3000 x3500) x1001
     (Curry_Prelude.Guard_OP_List x1000 x1001) -> guardCons x1000 ((nd_OP__case_3 x3 x7 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_2 x3 x7 x3500 = case x7 of
     (Curry_Prelude.OP_Tuple2 x13 x14) -> Curry_Maybe.d_C_fromMaybe Curry_Base.C_FO (Curry_FiniteMap.d_C_lookupFM x3 (Curry_Prelude.OP_Tuple2 x13 x14) x3500) x3500
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002) -> narrow x1000 (d_OP__case_2 x3 x1001 x3500) (d_OP__case_2 x3 x1002 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_2 x3 z x3500) x1001
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001) -> guardCons x1000 ((d_OP__case_2 x3 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_2 x3 x7 x3000 x3500 = case x7 of
     (Curry_Prelude.OP_Tuple2 x13 x14) -> let
          x2000 = x3000
           in (seq x2000 (Curry_Maybe.d_C_fromMaybe Curry_Base.C_FO (Curry_FiniteMap.nd_C_lookupFM x3 (Curry_Prelude.OP_Tuple2 x13 x14) x2000 x3500) x3500))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_2 x3 x1001 x3000 x3500) (nd_OP__case_2 x3 x1002 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_2 x3 z x3000 x3500) x1001
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001) -> guardCons x1000 ((nd_OP__case_2 x3 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_4 x6 x7 x3500 = case x7 of
     Curry_Prelude.C_True -> Curry_Base.C_HO
     Curry_Prelude.C_False -> Curry_Base.C_FO
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (d_OP__case_4 x6 x1001 x3500) (d_OP__case_4 x6 x1002 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_4 x6 z x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((d_OP__case_4 x6 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_4 x6 x7 x3000 x3500 = case x7 of
     Curry_Prelude.C_True -> Curry_Base.C_HO
     Curry_Prelude.C_False -> Curry_Base.C_FO
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_4 x6 x1001 x3000 x3500) (nd_OP__case_4 x6 x1002 x3000 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_4 x6 z x3000 x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((nd_OP__case_4 x6 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_8 x1 x3 x3500 = case x3 of
     (C_T x5) -> d_OP__case_7 x1 x5 x3500
     (C_F x14) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_funcName x3500) x14 x3500) (d_C_ordHelp2 (Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_funcType x3500) x14 x3500) (Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_funcArity x3500) x14 x3500) x1 x3500)
     (Choice_C_Declaration x1000 x1001 x1002) -> narrow x1000 (d_OP__case_8 x1 x1001 x3500) (d_OP__case_8 x1 x1002 x3500)
     (Choices_C_Declaration x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_8 x1 z x3500) x1001
     (Guard_C_Declaration x1000 x1001) -> guardCons x1000 ((d_OP__case_8 x1 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_8 x1 x3 x3000 x3500 = case x3 of
     (C_T x5) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_7 x1 x5 x2000 x3500))
     (C_F x14) -> let
          x2012 = x3000
           in (seq x2012 (let
               x2002 = leftSupply x2012
               x2010 = rightSupply x2012
                in (seq x2002 (seq x2010 (Curry_Prelude.OP_Tuple2 (let
                    x2001 = leftSupply x2002
                    x2000 = rightSupply x2002
                     in (seq x2001 (seq x2000 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_funcName x2000 x3500) x14 x2001 x3500)))) (let
                    x2009 = leftSupply x2010
                    x2011 = rightSupply x2010
                     in (seq x2009 (seq x2011 (let
                         x2005 = leftSupply x2011
                         x2008 = rightSupply x2011
                          in (seq x2005 (seq x2008 (nd_C_ordHelp2 (let
                              x2004 = leftSupply x2005
                              x2003 = rightSupply x2005
                               in (seq x2004 (seq x2003 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_funcType x2003 x3500) x14 x2004 x3500)))) (let
                              x2007 = leftSupply x2008
                              x2006 = rightSupply x2008
                               in (seq x2007 (seq x2006 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_funcArity x2006 x3500) x14 x2007 x3500)))) x1 x2009 x3500))))))))))))
     (Choice_C_Declaration x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_8 x1 x1001 x3000 x3500) (nd_OP__case_8 x1 x1002 x3000 x3500)
     (Choices_C_Declaration x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_8 x1 z x3000 x3500) x1001
     (Guard_C_Declaration x1000 x1001) -> guardCons x1000 ((nd_OP__case_8 x1 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_7 x1 x5 x3500 = case x5 of
     (Curry_FlatCurry.C_Type x6 x7 x8 x9) -> Curry_Prelude.OP_Tuple2 x6 (d_C_goThroughConsList x1 x9 x3500)
     (Curry_FlatCurry.C_TypeSyn x10 x11 x12 x13) -> Curry_Prelude.OP_Tuple2 x10 (d_C_ordHelp1 x1 x13 x3500)
     (Curry_FlatCurry.Choice_C_TypeDecl x1000 x1001 x1002) -> narrow x1000 (d_OP__case_7 x1 x1001 x3500) (d_OP__case_7 x1 x1002 x3500)
     (Curry_FlatCurry.Choices_C_TypeDecl x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_7 x1 z x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeDecl x1000 x1001) -> guardCons x1000 ((d_OP__case_7 x1 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_7 x1 x5 x3000 x3500 = case x5 of
     (Curry_FlatCurry.C_Type x6 x7 x8 x9) -> let
          x2000 = x3000
           in (seq x2000 (Curry_Prelude.OP_Tuple2 x6 (nd_C_goThroughConsList x1 x9 x2000 x3500)))
     (Curry_FlatCurry.C_TypeSyn x10 x11 x12 x13) -> let
          x2000 = x3000
           in (seq x2000 (Curry_Prelude.OP_Tuple2 x10 (nd_C_ordHelp1 x1 x13 x2000 x3500)))
     (Curry_FlatCurry.Choice_C_TypeDecl x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_7 x1 x1001 x3000 x3500) (nd_OP__case_7 x1 x1002 x3000 x3500)
     (Curry_FlatCurry.Choices_C_TypeDecl x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_7 x1 z x3000 x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeDecl x1000 x1001) -> guardCons x1000 ((nd_OP__case_7 x1 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_9 x3 x2 x3500 = case x2 of
     (Curry_FlatCurry.C_FuncType x4 x5) -> Curry_Base.C_HO
     (Curry_FlatCurry.C_TCons x6 x7) -> d_OP_consOrder_dot_consOrder'_dot_81 (Curry_Prelude.d_OP_plus_plus x7 x3 x3500) x3500
     (Curry_FlatCurry.C_TVar x8) -> d_OP_consOrder_dot_consOrder'_dot_81 x3 x3500
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002) -> narrow x1000 (d_OP__case_9 x3 x1001 x3500) (d_OP__case_9 x3 x1002 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_9 x3 z x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001) -> guardCons x1000 ((d_OP__case_9 x3 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_9 x3 x2 x3000 x3500 = case x2 of
     (Curry_FlatCurry.C_FuncType x4 x5) -> Curry_Base.C_HO
     (Curry_FlatCurry.C_TCons x6 x7) -> d_OP_consOrder_dot_consOrder'_dot_81 (Curry_Prelude.d_OP_plus_plus x7 x3 x3500) x3500
     (Curry_FlatCurry.C_TVar x8) -> d_OP_consOrder_dot_consOrder'_dot_81 x3 x3500
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_9 x3 x1001 x3000 x3500) (nd_OP__case_9 x3 x1002 x3000 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_9 x3 z x3000 x3500) x1001
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001) -> guardCons x1000 ((nd_OP__case_9 x3 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_13 x5 x6 x7 x8 x9 x3500 = case x9 of
     Curry_Prelude.C_True -> x8
     Curry_Prelude.C_False -> d_OP__case_12 x5 x6 x7 x8 (Curry_Prelude.d_C_apply (d_C_isNDExpr x3500) (Curry_Prelude.d_C_apply (Curry_FlatCurryGoodies.d_C_ruleBody x3500) x6 x3500) x3500) x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (d_OP__case_13 x5 x6 x7 x8 x1001 x3500) (d_OP__case_13 x5 x6 x7 x8 x1002 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_13 x5 x6 x7 x8 z x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((d_OP__case_13 x5 x6 x7 x8 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_13 x5 x6 x7 x8 x9 x3000 x3500 = case x9 of
     Curry_Prelude.C_True -> x8
     Curry_Prelude.C_False -> let
          x2008 = x3000
           in (seq x2008 (let
               x2007 = leftSupply x2008
               x2005 = rightSupply x2008
                in (seq x2007 (seq x2005 (nd_OP__case_12 x5 x6 x7 x8 (let
                    x2004 = leftSupply x2005
                    x2006 = rightSupply x2005
                     in (seq x2004 (seq x2006 (let
                         x2000 = leftSupply x2006
                         x2003 = rightSupply x2006
                          in (seq x2000 (seq x2003 (Curry_Prelude.nd_C_apply (nd_C_isNDExpr x2000 x3500) (let
                              x2002 = leftSupply x2003
                              x2001 = rightSupply x2003
                               in (seq x2002 (seq x2001 (Curry_Prelude.nd_C_apply (Curry_FlatCurryGoodies.nd_C_ruleBody x2001 x3500) x6 x2002 x3500)))) x2004 x3500))))))) x2007 x3500)))))
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_13 x5 x6 x7 x8 x1001 x3000 x3500) (nd_OP__case_13 x5 x6 x7 x8 x1002 x3000 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_13 x5 x6 x7 x8 z x3000 x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((nd_OP__case_13 x5 x6 x7 x8 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_12 x5 x6 x7 x8 x9 x3500 = case x9 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x5 Curry_Base.C_ND
     Curry_Prelude.C_False -> d_OP__case_11 x5 x8 x7 x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (d_OP__case_12 x5 x6 x7 x8 x1001 x3500) (d_OP__case_12 x5 x6 x7 x8 x1002 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_12 x5 x6 x7 x8 z x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((d_OP__case_12 x5 x6 x7 x8 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_12 x5 x6 x7 x8 x9 x3000 x3500 = case x9 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x5 Curry_Base.C_ND
     Curry_Prelude.C_False -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_11 x5 x8 x7 x2000 x3500))
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_12 x5 x6 x7 x8 x1001 x3000 x3500) (nd_OP__case_12 x5 x6 x7 x8 x1002 x3000 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_12 x5 x6 x7 x8 z x3000 x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((nd_OP__case_12 x5 x6 x7 x8 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_11 x5 x8 x7 x3500 = case x7 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x5 Curry_Base.C_ND
     Curry_Prelude.C_False -> d_OP__case_10 x8 (Curry_Prelude.d_C_otherwise x3500) x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (d_OP__case_11 x5 x8 x1001 x3500) (d_OP__case_11 x5 x8 x1002 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_11 x5 x8 z x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((d_OP__case_11 x5 x8 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_11 x5 x8 x7 x3000 x3500 = case x7 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 x5 Curry_Base.C_ND
     Curry_Prelude.C_False -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_10 x8 (Curry_Prelude.d_C_otherwise x3500) x2000 x3500))
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_11 x5 x8 x1001 x3000 x3500) (nd_OP__case_11 x5 x8 x1002 x3000 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_11 x5 x8 z x3000 x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((nd_OP__case_11 x5 x8 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_10 x8 x9 x3500 = case x9 of
     Curry_Prelude.C_True -> x8
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (d_OP__case_10 x8 x1001 x3500) (d_OP__case_10 x8 x1002 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_10 x8 z x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((d_OP__case_10 x8 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_10 x8 x9 x3000 x3500 = case x9 of
     Curry_Prelude.C_True -> x8
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_10 x8 x1001 x3000 x3500) (nd_OP__case_10 x8 x1002 x3000 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_10 x8 z x3000 x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((nd_OP__case_10 x8 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_14 x2 x3 x3500 = case x3 of
     Curry_Prelude.C_True -> Curry_Base.C_ND
     Curry_Prelude.C_False -> Curry_Base.C_D
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (d_OP__case_14 x2 x1001 x3500) (d_OP__case_14 x2 x1002 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_14 x2 z x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((d_OP__case_14 x2 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_14 x2 x3 x3000 x3500 = case x3 of
     Curry_Prelude.C_True -> Curry_Base.C_ND
     Curry_Prelude.C_False -> Curry_Base.C_D
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_14 x2 x1001 x3000 x3500) (nd_OP__case_14 x2 x1002 x3000 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_14 x2 z x3000 x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((nd_OP__case_14 x2 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons

d_OP__case_15 x1 x2 x3 x4 x5 x6 x3500 = case x6 of
     Curry_Prelude.C_True -> x4
     Curry_Prelude.C_False -> d_C_fullIteration x1 x2 x3 x5 x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (d_OP__case_15 x1 x2 x3 x4 x5 x1001 x3500) (d_OP__case_15 x1 x2 x3 x4 x5 x1002 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> d_OP__case_15 x1 x2 x3 x4 x5 z x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((d_OP__case_15 x1 x2 x3 x4 x5 x1001) $! (addCs x1000 x3500))
     _ -> failCons

nd_OP__case_15 x1 x2 x3 x4 x5 x6 x3000 x3500 = case x6 of
     Curry_Prelude.C_True -> x4
     Curry_Prelude.C_False -> let
          x2000 = x3000
           in (seq x2000 (nd_C_fullIteration x1 x2 x3 x5 x2000 x3500))
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002) -> narrow x1000 (nd_OP__case_15 x1 x2 x3 x4 x5 x1001 x3000 x3500) (nd_OP__case_15 x1 x2 x3 x4 x5 x1002 x3000 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001) -> narrows x3500 x1000 (\z -> nd_OP__case_15 x1 x2 x3 x4 x5 z x3000 x3500) x1001
     (Curry_Prelude.Guard_C_Bool x1000 x1001) -> guardCons x1000 ((nd_OP__case_15 x1 x2 x3 x4 x5 x1001 x3000) $! (addCs x1000 x3500))
     _ -> failCons
